////////////////////////////////////////////////////////////////////////////
//
// dv(ECv)ǂ.
//
// copyright by rubidesu 2015
// http://www.gatelink.co.jp/hw/
//
////////////////////////////////////////////////////////////////////////////

#define _SEND_SERIAL_
//#undef _SEND_SERIAL_

#include <16f688.H>
#device ADC=10

#USE FAST_IO(C)

#fuses INTRC_IO, NOWDT, PUT, NOPROTECT, NOMCLR, NOBROWNOUT

#use delay(clock=2000000)

#ifdef _SEND_SERIAL_
#use rs232(BAUD=9600, XMIT=PIN_C5)
#endif //_SEND_SERIAL_

struct tagPORTA{
	short bit0;
	short bit1;
	short bit2;
	short bit3;
	short bit4;
	short bit5;
	short bit6;
	short bit7;
}PORTA;
#byte PORTA = 5

struct tagPORTC{
	short bit0;
	short bit1;
	short bit2;
	short bit3;
	short bit4;
	short bit5;
	short bit6;
	short bit7;
}PORTC;
#byte PORTC = 7

typedef unsigned int1	BIT;
typedef unsigned int16	WORD;
typedef unsigned int32	DWORD;

#define HIGH	1
#define LOW		0

//ݒXCb`̃|[g.
#define PUSH_SW		PORTA.bit5

//LCD̃|[g.
#define LCD_RS PORTC.bit2
#define LCD_EN PORTC.bit1

const BYTE cgram_vertical[64] = {
	//CGRAM(1)     #####
	0b00001111,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	//CGRAM(2)     #####
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001111,	//
	//CGRAM(3)     #####
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	//CGRAM(4)     #####
	0b00001111,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00001111,	//
	//CGRAM(5)     #####
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001111,	//
	//CGRAM(6)     #####
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00000001,	//
	0b00001111,	//
	//CGRAM(7)     #####
	0b00001111,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001000,	//
	0b00001111,	//
	//CGRAM(8)     #####
	0b00001111,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001001,	//
	0b00001111,	//
};
//                                     0     1     2     3     4     5     6     7     8     9     SP.
const BYTE font_table_vertical1[11] = {0x00, 0x02, 0x03, 0x03, 0x01, 0x06, 0x06, 0x00, 0x07, 0x07, 0x20};
const BYTE font_table_vertical2[11] = {0x01, 0x02, 0x04, 0x05, 0x02, 0x05, 0x01, 0x02, 0x01, 0x05, 0x20};

//RfT[dp̃|[g.
#define CHARGE_PORT		PORTC.bit4

//ωobt@.
#define AVERAGE_SIZE		10
WORD wAverage[AVERAGE_SIZE];
BYTE bAveragePnt = 0;

//LCD\px.
#define PRINT_INTERVAL		5

//ϊp̕ϐ.
BYTE bConvTemp[12];
BYTE bConvTempPnt = 0;

//LCD\[h 0:傫tHg 1:ڍו\.
#define PRINT_MODE_MAX	2
BYTE bPrintMode = 0;

//XCb`̉.
#define SW_NONE		0
#define SW_SHORT	1
#define SW_LONG		2
//XCb`tO.
BYTE bSWLongFlg = FALSE;

//␳lƂ̃ftHgl.
#define CORRECTION_DEF	0
WORD wCorrectionVal = 0;

#define PRINT_IND_MAX	2
const BYTE bPrintInd[PRINT_IND_MAX] = {'|', '-'};
BYTE bPrintIndPnt = 0;

////////////////////////////////////////////////////////////////////////////
void tostring(char c)
{
	if(c == '\f'){
		bConvTempPnt = 0;
	}
	else{
		bConvTemp[bConvTempPnt++] = c;
	}
}

////////////////////////////////////////////////////////////////////////////
void print_string(char c)
{
	putc(c);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_strobe(void)
{
	LCD_EN = HIGH;
	LCD_EN = LOW;
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_write(unsigned char c)
{
#if 1
	output_bit(PIN_C0, (c >> 4) & 0x01);
	output_bit(PIN_A2, (c >> 5) & 0x01);
	output_bit(PIN_A1, (c >> 6) & 0x01);
	output_bit(PIN_A0, (c >> 7) & 0x01);
	lcd_strobe();
	output_bit(PIN_C0, (c >> 0) & 0x01);
	output_bit(PIN_A2, (c >> 1) & 0x01);
	output_bit(PIN_A1, (c >> 2) & 0x01);
	output_bit(PIN_A0, (c >> 3) & 0x01);
	lcd_strobe();
#else
	LCD_DAT = (LCD_DAT & 0xF0) | (c >> 4);
	lcd_strobe();
	LCD_DAT = (LCD_DAT & 0xF0) | (c & 0x0F);
	lcd_strobe();
#endif
	delay_us(40);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_clear(void)
{
	//output_low(LCD_RS);
	LCD_RS = LOW;
	lcd_write(0x1);
	delay_ms(2);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_putch(unsigned char c)
{
	//output_high(LCD_RS);
	LCD_RS = HIGH;
	lcd_write(c);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_goto(unsigned char pos)
{
	//output_low(LCD_RS);
	LCD_RS = LOW;
	lcd_write(0x80+pos);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_init(void)
{
	//output_low(LCD_RS);
	LCD_RS = LOW;
	delay_ms(15);

	output_high(PIN_C0);
	output_high(PIN_A2);
	output_low(PIN_A1);
	output_low(PIN_A0);
	lcd_strobe();
	delay_ms(5);

	lcd_strobe();
	delay_us(100);

	lcd_strobe();
	delay_ms(5);

	output_low(PIN_C0);
	output_high(PIN_A2);
	output_low(PIN_A1);
	output_low(PIN_A0);
	lcd_strobe();
	delay_us(40);

	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0C);	// display on, blink curson off
	lcd_write(0x06);	// entry mode
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_set_cgram_vertical(void)
{
	BYTE i;

	LCD_RS = LOW;
	lcd_write(0x40);

	LCD_RS = HIGH;

	for(i = 0; i < 64; i++){
		lcd_write(cgram_vertical[i]);
	}
}

////////////////////////////////////////////////////////////////////////////
BYTE get_sw1()
{
	WORD wCnt = 0;

	if((bSWLongFlg == TRUE) && (PUSH_SW == LOW)){
		return SW_NONE;
	}
	else{
		bSWLongFlg = FALSE;
	}

	if(PUSH_SW == LOW){		//DOWN
		delay_ms(10);
		for(wCnt = 0; wCnt < 300; wCnt++){
			if(PUSH_SW == HIGH){
				//3bȓɗꂽZƂ.
				return SW_SHORT;
			}
			delay_ms(10);
		}
		bSWLongFlg = TRUE;
#if 0
		while(1){
			if(PUSH_SW == HIGH){
				break;
			}
		}
#endif
		return SW_LONG;
	}

	return SW_NONE;
}

////////////////////////////////////////////////////////////////////////////
VOID print_word(WORD val)
{
	lcd_putch((val / 1000) + '0');
	val %= 1000;

	lcd_putch((val / 100) + '0');
	val %= 100;

	lcd_putch((val / 10) + '0');
	val %= 10;

	lcd_putch(val + '0');
}

////////////////////////////////////////////////////////////////////////////
#ifdef _SEND_SERIAL_
VOID send_word(WORD val)
{
	putc((val / 1000) + '0');
	val %= 1000;

	putc((val / 100) + '0');
	val %= 100;

	putc((val / 10) + '0');
	val %= 10;

	putc(val + '0');
}
#endif //_SEND_SERIAL_

////////////////////////////////////////////////////////////////////////////
void space_to_num(BYTE n)
{
	BYTE i;

	//pXy[X : ɒu.
	for(i = 0; i < n; i++){
		if(bConvTemp[i] == ' '){
			bConvTemp[i] = ':';
		}
	}
}

////////////////////////////////////////////////////////////////////////////
VOID print_vertical(float fReadVal)
{
	printf(tostring, "\f%6.1f", fReadVal);
	space_to_num(3);

	//[̂Ƃ .0 ɂȂ̂0t.
	if(bConvTemp[3] == ' '){
		bConvTemp[3] = '0';
	}

	//1sڂ̕\.
	lcd_goto(0x01);
	lcd_putch(font_table_vertical1[bConvTemp[0] - '0']);
	lcd_putch(font_table_vertical1[bConvTemp[1] - '0']);
	lcd_putch(font_table_vertical1[bConvTemp[2] - '0']);
	lcd_putch(font_table_vertical1[bConvTemp[3] - '0']);
	lcd_putch(' ');
	lcd_putch(font_table_vertical1[bConvTemp[5] - '0']);

	//2sڂ̕\.
	lcd_goto(0x41);
	lcd_putch(font_table_vertical2[bConvTemp[0] - '0']);
	lcd_putch(font_table_vertical2[bConvTemp[1] - '0']);
	lcd_putch(font_table_vertical2[bConvTemp[2] - '0']);
	lcd_putch(font_table_vertical2[bConvTemp[3] - '0']);
	lcd_putch('.');
	lcd_putch(font_table_vertical2[bConvTemp[5] - '0']);
	lcd_putch(bPrintInd[bPrintIndPnt]);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
float PushValue(WORD wValue)
{
	BYTE i;
	BYTE wValueCnt = 0;
	DWORD dwTotal = 0;

	//ωobt@ɒlāA|C^i߂.
	wAverage[bAveragePnt] = wValue;
	bAveragePnt++;
	bAveragePnt %= AVERAGE_SIZE;

	//obt@̒lo.
	for(i = 0; i < AVERAGE_SIZE; i++){
		if(wAverage[i] != 0){
			dwTotal += wAverage[i];
			wValueCnt++;
		}
	}

	//obt@̍v/obt@̗vfŕϒlԂ.
	if(wValueCnt == 0){
		return 0.0;
	}
	else{
		return (float)((double)dwTotal / (double)wValueCnt);
	}
}

BYTE wait_discharge(WORD wNum, WORD wVoltage)
{
	WORD i;
	WORD wReadRealVal;

	for(i = 0; i < wNum; i++){
		set_adc_channel(7);
		delay_us(50);
		wReadRealVal = read_adc();
		if(wReadRealVal < wVoltage){
#if 1
			putc('[');
			send_word(wReadRealVal);
			putc(']');
#endif
			return TRUE;
		}
	}

#if 1
	putc('[');
	send_word(wReadRealVal);
	putc(']');
#endif

	return FALSE;
}

////////////////////////////////////////////////////////////////////////////
// C.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
main()
{
	WORD wReadRealVal;
	WORD wReadCorrectionVal;
	WORD i;
	float fReadVal;
	BYTE bPrintCnt = 0;
	BYTE bKey;

	//낢돉.
	set_tris_a(0b00111000);
	set_tris_c(0b00001000);
	setup_oscillator(OSC_2MHZ);
	setup_comparator(NC_NC_NC_NC);
	setup_adc(ADC_CLOCK_DIV_8);
	setup_adc_ports(sAN7 | VSS_VDD);
	setup_vref(FALSE);

	//[d|[gOFF.
	CHARGE_PORT = LOW;

	//ωobt@̏.
	for(i = 0; i < AVERAGE_SIZE; i++){
		wAverage[i] = 0;
	}

	//Ôߑ҂.
	delay_ms(100);

	lcd_init();
	lcd_set_cgram_vertical();
	lcd_clear();

	wCorrectionVal = read_eeprom(0x00) << 8;
	wCorrectionVal |= read_eeprom(0x01);
	if((wCorrectionVal >= 0x3ff)){
		//EEPROM̒lςȒlȂ珉l.
		wCorrectionVal = CORRECTION_DEF;
		write_eeprom(0, (BYTE)(wCorrectionVal >> 8));
		write_eeprom(1, (BYTE)(wCorrectionVal & 0x00ff));
	}

	set_adc_channel(7);			//ADϊJn.

	while(1){
		CHARGE_PORT = LOW;	//dJn.

		//܂0V߂܂ŕd݂.
		if(wait_discharge(20, 2) == FALSE){
			//0VȂ0.1Vx܂Ŏ݂(3.3V / 1024 * 32  0.1V).
			wait_discharge(20, 32);
		}
		else{
			print_string("[0000]");
		}

		set_adc_channel(7);			//ADϊJn.

		CHARGE_PORT = HIGH;			//[dJn.

		delay_us(150);				//[d.

		wReadRealVal = read_adc();	//ADϊl̓ǂݍ.

		CHARGE_PORT = LOW;			//[dI.

		//l␳.
		if(wReadRealVal < wCorrectionVal){
			wReadCorrectionVal = 0;
		}
		else{
			wReadCorrectionVal = wReadRealVal - wCorrectionVal;
		}

		//ωobt@֒l.
		fReadVal = PushValue(wReadCorrectionVal);

		if(bPrintCnt == 0){
			if(bPrintMode == 0){		//傫tHgŕ`.
				print_vertical(fReadVal);
				//putc('P');
			}
			else if(bPrintMode == 1){	//ڍו\.
				lcd_goto(0x00);
				printf(lcd_putch, "A:%06.1f", fReadVal);
				lcd_goto(0x40);
				printf(lcd_putch, "R:%06lu", wReadRealVal);
			}

			bPrintIndPnt = bPrintIndPnt + 1;
			bPrintIndPnt = bPrintIndPnt % PRINT_IND_MAX;
		}
		//v񐔂Ɉx̕pxŕ`悷.
		bPrintCnt = bPrintCnt + 1;
		bPrintCnt = bPrintCnt % PRINT_INTERVAL;

		bKey = get_sw1();
		if(bKey == SW_SHORT){
			lcd_clear();
			bPrintCnt = 0;	//Iɍĕ`.

			//\[hύX.
			bPrintMode = bPrintMode + 1;
			bPrintMode = bPrintMode % PRINT_MODE_MAX;
		}
		else if(bKey == SW_LONG){
			//␳lEEPROMɏ.
			wCorrectionVal = wReadRealVal;
			write_eeprom(0, (BYTE)(wCorrectionVal >> 8));
			write_eeprom(1, (BYTE)(wCorrectionVal & 0x00ff));

			lcd_clear();

			lcd_goto(0x00);
			lcd_putch('S');
			lcd_putch('e');
			lcd_putch('t');

			delay_ms(2000);

			lcd_clear();

			bPrintCnt = 0;	//Iɍĕ`.
		}

		#ifdef _SEND_SERIAL_
			send_word(wReadRealVal);
			putc('\r');
			putc('\n');
		#endif //_SEND_SERIAL_

		#ifdef _SEND_SERIAL_
			delay_ms(50);
		#else
			delay_ms(75);
		#endif //_SEND_SERIAL_
	}
}

